/* http://keith-wood.name/keypad.html
   Keypad field entry extension for jQuery v1.0.0.
   Written by Keith Wood (kbwood@virginbroadband.com.au) August 2008.
   Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and 
   MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses. 
   Please attribute the author if you use it. */
(function($){var r='keypad';function Keypad(){this._curInst=null;this._disabledFields=[];this._keypadShowing=false;this._mainDivId='keypad-div';this._appendClass='keypad-append';this._triggerClass='keypad-trigger';this._uuid=new Date().getTime();this.regional=[];this.regional['']={buttonText:'...',buttonStatus:'Open the keypad',closeText:'Close',closeStatus:'Close the keypad',clearText:'Clear',clearStatus:'Erase all the text',backText:'Back',backStatus:'Erase the previous character',shiftText:'Shift',shiftStatus:'Toggle upper/lower case characters',alphabeticLayout:this.qwertyAlphabetic,fullLayout:this.qwertyLayout,isAlphabetic:this.isAlphabetic,isNumeric:this.isNumeric,isRTL:false};this._defaults={showOn:'focus',buttonImage:'',buttonImageOnly:false,showAnim:'show',showOptions:{},duration:'normal',appendText:'',keypadClass:'',prompt:'',layout:['123'+this.CLOSE,'456'+this.CLEAR,'789'+this.BACK,this.SPACE+'0'],keypadOnly:true,randomiseAlphabetic:false,randomiseNumeric:false,randomiseOther:false,onKeypress:null,onClose:null};$.extend(this._defaults,this.regional['']);this.mainDiv=$('<div id="'+this._mainDivId+'" style="display: none;"></div>')}var s='\x00';var t='\x01';var u='\x02';var v='\x03';var w='\x04';var x='\x05';$.extend(Keypad.prototype,{CLOSE:s,CLEAR:t,BACK:u,SHIFT:v,SPACE:w,HALF_SPACE:x,qwertyAlphabetic:['qwertyuiop','asdfghjkl','zxcvbnm'],qwertyLayout:['!@#$%^&*()_=','`~[]{}<>\\|/?'+x+'789','qwertyuiop\'"'+x+'456',x+'asdfghjkl;:'+w+'123',w+'zxcvbnm ,.'+w+x+'-0+',w+w+v+w+u+w+t+w+s],markerClassName:'hasKeypad',setDefaults:function(a){extendRemove(this._defaults,a||{});return this},_attachKeypad:function(a,b){if(!a.id){a.id='kp'+ ++this._uuid}var c=this._newInst($(a));c.settings=$.extend({},b||{});this._connectKeypad(a,c)},_newInst:function(a){var b=a[0].id.replace(/([:\[\]\.])/g,'\\\\$1');return{id:b,field:a,mainDiv:$.keypad.mainDiv,ucase:false}},_connectKeypad:function(d,e){var f=$(d);if(f.hasClass(this.markerClassName)){return}var g=this._get(e,'appendText');var h=this._get(e,'isRTL');if(g){f[h?'before':'after']('<span class="'+this._appendClass+'">'+g+'</span>')}var i=this._get(e,'showOn');if(i=='focus'||i=='both'){f.focus(this._showKeypad)}if(i=='button'||i=='both'){var j=this._get(e,'buttonText');var k=this._get(e,'buttonStatus');var l=this._get(e,'buttonImage');var m=$(this._get(e,'buttonImageOnly')?$('<img/>').attr({src:l,alt:k,title:k}):$('<button type="button" title="'+k+'"></button>').html(l==''?j:$('<img/>').attr({src:l})));f[h?'before':'after'](m);m.addClass(this._triggerClass).click(function(){if($.keypad._keypadShowing&&$.keypad._lastField==d){$.keypad._hideKeypad()}else{$.keypad._showKeypad(d)}return false})}e.saveReadonly=f.attr('readonly');f.addClass(this.markerClassName).attr('readonly',(this._get(e,'keypadOnly')?'readonly':'')).bind("setData.keypad",function(a,b,c){e.settings[b]=c}).bind("getData.keypad",function(a,b){return this._get(e,b)});$.data(d,r,e)},_destroyKeypad:function(a){var b=$(a);if(!b.hasClass(this.markerClassName)){return}var c=$.data(a,r);if(this._curInst==c){this._hideKeypad(null)}b.siblings('.'+this._appendClass).remove().end().siblings('.'+this._triggerClass).remove().end().removeClass(this.markerClassName).attr('readonly',c.saveReadonly).unbind('focus',this._showKeypad);$.removeData(a,r)},_enableKeypad:function(b){var c=$(b);if(!c.hasClass(this.markerClassName)){return}b.disabled=false;c.siblings('button.'+this._triggerClass).each(function(){this.disabled=false}).end().siblings('img.'+this._triggerClass).css({opacity:'1.0',cursor:''});this._disabledFields=$.map(this._disabledFields,function(a){return(a==b?null:a)})},_disableKeypad:function(b){var c=$(b);if(!c.hasClass(this.markerClassName)){return}b.disabled=true;c.siblings('button.'+this._triggerClass).each(function(){this.disabled=true}).end().siblings('img.'+this._triggerClass).css({opacity:'0.5',cursor:'default'});this._disabledFields=$.map(this._disabledFields,function(a){return(a==b?null:a)});this._disabledFields[this._disabledFields.length]=b},_isDisabledKeypad:function(a){return(a&&$.inArray(a,this._disabledFields)>-1)},_changeKeypad:function(a,b,c){var d=b||{};if(typeof b=='string'){d={};d[b]=c}var e=$.data(a,r);if(e){if(this._curInst==e){this._hideKeypad(null)}extendRemove(e.settings,d);this._updateKeypad(e)}},_showKeypad:function(a){a=a.target||a;if($.keypad._isDisabledKeypad(a)||$.keypad._lastField==a){return}var b=$.data(a,r);$.keypad._hideKeypad(null,'');$.keypad._lastField=a;$.keypad._pos=$.keypad._findPos(a);$.keypad._pos[1]+=a.offsetHeight;var c=false;$(a).parents().each(function(){c|=$(this).css('position')=='fixed';return!c});if(c&&$.browser.opera){$.keypad._pos[0]-=document.documentElement.scrollLeft;$.keypad._pos[1]-=document.documentElement.scrollTop}var d={left:$.keypad._pos[0],top:$.keypad._pos[1]};$.keypad._pos=null;b.mainDiv.css({position:'absolute',display:'block',top:'-1000px',width:($.browser.opera?'1000px':'auto')});$.keypad._updateKeypad(b);d=$.keypad._checkOffset(b,d,c);b.mainDiv.css({position:(c?'fixed':'absolute'),display:'none',left:d.left+'px',top:d.top+'px'});var e=$.keypad._get(b,'showAnim')||'show';var f=$.keypad._get(b,'duration');var g=function(){$.keypad._keypadShowing=true;if($.browser.msie&&parseInt($.browser.version)<7){$('iframe.keypad-cover').css({width:b.mainDiv.width()+4,height:b.mainDiv.height()+4})}};if($.effects&&$.effects[e]){b.mainDiv.show(e,$.keypad._get(b,'showOptions'),f,g)}else{b.mainDiv[e](f,g)}if(f==''){g()}if(b.field[0].type!='hidden'){b.field[0].focus()}$.keypad._curInst=b},_updateKeypad:function(a){var b={width:a.mainDiv.width()+4,height:a.mainDiv.height()+4};a.mainDiv.empty().append(this._generateHTML(a)).find('iframe.keypad-cover').css({width:b.width,height:b.height});a.mainDiv.removeClass().addClass(this._get(a,'keypadClass')+(this._get(a,'isRTL')?' keypad-rtl':''))},_checkOffset:function(a,b,c){var d=a.field?this._findPos(a.field[0]):null;var e=window.innerWidth||document.documentElement.clientWidth;var f=window.innerHeight||document.documentElement.clientHeight;var g=document.documentElement.scrollLeft||document.body.scrollLeft;var h=document.documentElement.scrollTop||document.body.scrollTop;if($.browser.opera){var i=0;$('.keypad-row',a.mainDiv).find('button:last').each(function(){i=Math.max(i,this.offsetLeft+this.offsetWidth+parseInt($(this).css('margin-right')))});a.mainDiv.css('width',i)}if(this._get(a,'isRTL')||(b.left+a.mainDiv.width()-g)>e){b.left=Math.max((c?0:g),d[0]+(a.field?a.field.width():0)-(c?g:0)-a.mainDiv.width()-(c&&$.browser.opera?document.documentElement.scrollLeft:0))}else{b.left-=(c?g:0)}if((b.top+a.mainDiv.height()-h)>f){b.top=Math.max((c?0:h),d[1]-(c?h:0)-(this._inDialog?0:a.mainDiv.height())-(c&&$.browser.opera?document.documentElement.scrollTop:0))}else{b.top-=(c?h:0)}return b},_findPos:function(a){while(a&&(a.type=='hidden'||a.nodeType!=1)){a=a.nextSibling}var b=$(a).offset();return[b.left,b.top]},_hideKeypad:function(a,b){var c=this._curInst;if(!c||(a&&c!=$.data(a,r))){return}if(this._keypadShowing){b=(b!=null?b:this._get(c,'duration'));var d=this._get(c,'showAnim');if(b!=''&&$.effects&&$.effects[d]){c.mainDiv.hide(d,$.keypad._get(c,'showOptions'),b)}else{c.mainDiv[(b==''?'hide':(d=='slideDown'?'slideUp':(d=='fadeIn'?'fadeOut':'hide')))](b)}var e=this._get(c,'onClose');if(e){e.apply((c.field?c.field[0]:null),[c.field.val(),c])}this._keypadShowing=false;this._lastField=null}this._curInst=null},_checkExternalClick:function(a){if(!$.keypad._curInst){return}var b=$(a.target);if(b[0].id!=$.keypad._mainDivId&&b.parents('#'+$.keypad._mainDivId).length==0&&!b.hasClass($.keypad.markerClassName)&&!b.hasClass($.keypad._triggerClass)&&$.keypad._keypadShowing){$.keypad._hideKeypad(null,'')}},_shiftKeypad:function(a){var b=$(a);var c=$.data(b[0],r);c.ucase=!c.ucase;this._updateKeypad(c);c.field.focus()},_clearValue:function(a){var b=$(a);var c=$.data(b[0],r);this._setValue(c,'',0)},_backValue:function(a){var b=$(a);var c=$.data(b[0],r);var d=c.field[0];var e=c.field.val();var f=[e.length,e.length];if(d.setSelectionRange){f=(c.field.attr('readonly')?f:[d.selectionStart,d.selectionEnd])}else if(d.createTextRange){f=(c.field.attr('readonly')?f:this._getIERange(d))}this._setValue(c,(e.length==0?'':e.substr(0,f[0]-1)+e.substr(f[1])),f[0]-1)},_selectValue:function(a,b){var c=$(a);var d=$.data(c[0],r);var e=d.field[0];var f=d.field.val();var g=[f.length,f.length];if(e.setSelectionRange){g=(d.field.attr('readonly')?g:[e.selectionStart,e.selectionEnd])}else if(e.createTextRange){g=(d.field.attr('readonly')?g:this._getIERange(e))}var h=g[0]+b.length;b=f.substr(0,g[0])+b+f.substr(g[1]);this._setValue(d,b,h)},_getIERange:function(e){e.focus();var f=document.selection.createRange().duplicate();var g=this._getIETextRange(e);g.setEndPoint('EndToStart',f);var h=function(a){var b=a.text;var c=b;var d=false;while(true){if(a.compareEndPoints('StartToEnd',a)==0){break}else{a.moveEnd('character',-1);if(a.text==b){c+='\r\n'}else{break}}}return c};var i=h(g);var j=h(f);return[i.length,i.length+j.length]},_getIETextRange:function(a){var b=(a.nodeName.toLowerCase()=='input');var c=(b?a.createTextRange():document.body.createTextRange());if(!b){c.moveToElementText(a)}return c},_setValue:function(a,b,c){a.field.val(b);var d=this._get(a,'onKeypress');if(d){d.apply((a.field?a.field[0]:null),[b,a])}else{a.field.trigger('change')}if(a.field.css('display')!='hidden'){a.field.focus()}var e=a.field[0];if(e.setSelectionRange){e.setSelectionRange(c,c)}else if(e.createTextRange){var f=e.createTextRange();f.move('character',c);f.select()}},_get:function(a,b){return a.settings[b]!==undefined?a.settings[b]:this._defaults[b]},_generateHTML:function(a){var b=this._get(a,'isRTL');var c=this._get(a,'prompt');var d=(!c?'':'<div class="keypad-prompt">'+c+'</div>');var e=this._randomiseLayout(a);for(var i=0;i<e.length;i++){d+='<div class="keypad-row">';for(var j=0;j<e[i].length;j++){var f=e[i].charAt(j);if(a.ucase){f=f.toUpperCase()}d+=(f==this.SPACE?'<div class="keypad-space"></div>':(f==this.HALF_SPACE?'<div class="keypad-half-space"></div>':'<button type="button" class="keypad-key'+(f==this.CLEAR?' keypad-clear':(f==this.BACK?' keypad-back':(f==this.CLOSE?' keypad-close':(f==this.SHIFT?' keypad-shift':''))))+'" '+'title="'+(f==this.CLEAR?this._get(a,'clearStatus'):(f==this.BACK?this._get(a,'backStatus'):(f==this.CLOSE?this._get(a,'closeStatus'):(f==this.SHIFT?this._get(a,'shiftStatus'):''))))+'" '+'onmousedown="jQuery(this).addClass(\'keypad-key-down\')" '+'onmouseup="jQuery(this).removeClass(\'keypad-key-down\')" '+'onmouseout="jQuery(this).removeClass(\'keypad-key-down\')" '+'onclick="jQuery.keypad.'+(f==this.CLEAR?'_clearValue(\'#'+a.id+'\')">'+this._get(a,'clearText'):(f==this.BACK?'_backValue(\'#'+a.id+'\')">'+this._get(a,'backText'):(f==this.CLOSE?'_hideKeypad()">'+this._get(a,'closeText'):(f==this.SHIFT?'_shiftKeypad(\'#'+a.id+'\')">'+this._get(a,'shiftText'):'_selectValue(\'#'+a.id+'\', \''+(f=='"'?'&quot;':(f=='\''||f=='\\'?'\\':'')+f)+'\')">'+(f==' '?'&nbsp;':f)))))+'</button>'))}d+='</div>'}d+='<div style="clear: both;"></div>'+($.browser.msie&&parseInt($.browser.version)<7?'<iframe src="javascript:false;" class="keypad-cover"></iframe>':'');return d},_randomiseLayout:function(a){var b=this._get(a,'randomiseNumeric');var c=this._get(a,'randomiseAlphabetic');var d=this._get(a,'randomiseOther');var e=this._get(a,'layout');if(!b&&!c&&!d){return e}var f=this._get(a,'isNumeric');var g=this._get(a,'isAlphabetic');var h=[];var k=[];var l=[];var m=[];for(var i=0;i<e.length;i++){m[i]='';for(var j=0;j<e[i].length;j++){var n=e[i].charAt(j);if(f(n)){if(b){h[h.length]=n}}else if(g(n)){if(c){k[k.length]=n}}else if(!this._isControl(n)){if(d){l[l.length]=n}}}}this._shuffle(h);this._shuffle(k);this._shuffle(l);var o=0;var p=0;var q=0;for(var i=0;i<e.length;i++){for(var j=0;j<e[i].length;j++){var n=e[i].charAt(j);if(this._isControl(n)){m[i]+=n}else if(f(n)){m[i]+=(b?h[o++]:n)}else if(g(n)){m[i]+=(c?k[p++]:n)}else{m[i]+=(d?l[q++]:n)}}}return m},_isControl:function(a){return a<' '},isAlphabetic:function(a){return(a>='A'&&a<='Z')||(a>='a'&&a<='z')},isNumeric:function(a){return(a>='0'&&a<='9')},_shuffle:function(a){for(var i=a.length-1;i>0;i--){var j=Math.floor(Math.random()*a.length);var b=a[i];a[i]=a[j];a[j]=b}}});function extendRemove(a,b){$.extend(a,b);for(var c in b){if(b[c]==null||b[c]==undefined){a[c]=b[c]}}return a};$.fn.keypad=function(a){var b=Array.prototype.slice.call(arguments,1);if(a=='isDisabled'){return $.keypad['_'+a+'Keypad'].apply($.keypad,[this[0]].concat(b))}return this.each(function(){typeof a=='string'?$.keypad['_'+a+'Keypad'].apply($.keypad,[this].concat(b)):$.keypad._attachKeypad(this,a)})};$.keypad=new Keypad();$(function(){$(document.body).append($.keypad.mainDiv).mousedown($.keypad._checkExternalClick)})})(jQuery);